//+------------------------------------------------------------------+                                                 VQ.mq4 |
//|                                                           VQ.mq4 |
//|                                               Volatility Quality |
//|                                     original   by raff1410@o2.pl |
//|                                     arranged   by k-matsu        |
//|                            ( http://www.age.jp/~k-matsu/FX/MT4/ )|
//+------------------------------------------------------------------+
#property  indicator_chart_window
#property  indicator_buffers 4
#property  indicator_color1  Green
#property  indicator_color2  Red
#property  indicator_color3  Green
#property  indicator_color4  Red
#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_width3  3
#property  indicator_width4  3
//----
extern   int      Length=5;
extern   int      Method=3;
extern   int      Smoothing=1;
extern   int      Filter=5;
extern   bool     Steady =false;
//----
double   VQ[];
double   SumVQ[];
double   DIR[];
double   ShadowBuffer1[];
double   ShadowBuffer2[];
double   BodyBuffer1[];
double   BodyBuffer2[];
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ShadowBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ShadowBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,BodyBuffer1);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,BodyBuffer2);
   SetIndexBuffer(4,SumVQ);
   SetIndexBuffer(5,VQ);
   SetIndexBuffer(6,DIR);

//----
   if (Length < 2) Length=2;
   if (Method < 0) Method=0;
   if (Method > 3) Method=3;
   if (Smoothing < 0) Smoothing=0;
   if (Filter < 0) Filter=0;
//----
   string short_name="VQ | "+ Length + " , " +
   Method + " , " + Smoothing + " , " + Filter + "  | ";
   IndicatorShortName(short_name);
   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexEmptyValue(2, 0.0);
   SetIndexEmptyValue(3, 0.0);
   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {
   double MH=0, ML=0, MO=0, MC=0, MC1=0;
   int i, j, limit, counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
//---- 
   if(counted_bars<1) i=Bars-Length-1;
   else i=Bars-counted_bars;
   if(counted_bars<1)
     {
      j=Bars-Length-1;
      SumVQ[j + 1]=Close[j + 1];
     }
   while(i>=0)
     {
      MH=iMA(NULL,0,Length,0,Method,PRICE_HIGH,i);
      ML=iMA(NULL,0,Length,0,Method,PRICE_LOW,i);
      MO=iMA(NULL,0,Length,0,Method,PRICE_OPEN,i);
      MC=iMA(NULL,0,Length,0,Method,PRICE_CLOSE,i);
      MC1=iMA(NULL,0,Length,0,Method,PRICE_CLOSE,i+Smoothing);
      if (Steady==true)
        {
         MC=iMA(NULL,0,Length,0,Method,PRICE_MEDIAN,i);
         MC1=iMA(NULL,0,Length,0,Method,PRICE_MEDIAN,i+Smoothing);
        }
      if((MH - ML)>0) VQ[i]=MathAbs(((MC - MC1)/MathMax(MH - ML, MathMax(MH - MC1, MC1 - ML)) + (MC - MO)/(MH - ML)) * 0.5) * ((MC - MC1 + (MC - MO)) * 0.5);
      SumVQ[i]=SumVQ[i + 1] + VQ[i];
      if (Filter > 0) if (MathAbs(SumVQ[i] - SumVQ[i + 1]) < Filter * Point) SumVQ[i]=SumVQ[i + 1];

      if (SumVQ[i] > SumVQ[i+1]) DIR[i]=1;
      if (SumVQ[i] < SumVQ[i+1]) DIR[i]=-1;
      if (SumVQ[i]== SumVQ[i+1]) DIR[i]=DIR[i + 1];
      if (DIR[i] > 0)
        {
         BodyBuffer1[i]=MathMax(MO,MC);
         BodyBuffer2[i]=MathMin(MO,MC);
        }
      else
        {
         BodyBuffer1[i]=MathMin(MO,MC);
         BodyBuffer2[i]=MathMax(MO,MC);
        }
      if (Close[i] > Open[i])
        {
         ShadowBuffer1[i]=MathMax(MathMax(MH,MC),MathMax(MO,ML));
         ShadowBuffer2[i]=MathMin(MathMin(MH,MO),MathMin(MC,ML));
        }
      else
        {
         ShadowBuffer1[i]=MathMin(MathMin(MH,MO),MathMin(MC,ML));
         ShadowBuffer2[i]=MathMax(MathMax(MH,MC),MathMax(MO,ML));
        }

      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+